Package net.shibboleth.idp.module

# Class PropertyDrivenIdPModule

java.lang.Object
net.shibboleth.profile.module.AbstractModule
net.shibboleth.profile.module.PropertyDrivenModule
net.shibboleth.idp.module.PropertyDrivenIdPModule

All Implemented Interfaces:
  `IdPModule`, `Module`, `Component`, `IdentifiedComponent`

Direct Known Subclasses:
  `CoreIdPModule`, `PluginIdPModule`

public class PropertyDrivenIdPModule extends PropertyDrivenModule implements IdPModule
Implementation of `IdPModule` relying on Java `Properties`. TODO: Make abstract in V6 and make all constructors protected.

Since:
  4.1.0

## Nested Class Summary

## Nested classes/interfaces inherited from class net.shibboleth.profile.module.AbstractModule

`AbstractModule.BasicModuleResource`

## Nested classes/interfaces inherited from interface net.shibboleth.profile.module.Module

`Module.ModuleResource, Module.ResourceResult`

## Field Summary

### Fields inherited from class net.shibboleth.profile.module.PropertyDrivenModule

`DEFAULT_RESOURCE, MODULE_DESC_PROPERTY, MODULE_DEST_PROPERTY, MODULE_EXEC_PROPERTY, MODULE_LANGS_PROPERTY, MODULE_NAME_PROPERTY, MODULE_NONWINDOWS_PROPERTY, MODULE_OPTIONAL_PROPERTY, MODULE_PLUGIN_PROPERTY, MODULE_POSTDISABLE_PROPERTY, MODULE_POSTENABLE_PROPERTY, MODULE_REPLACE_PROPERTY, MODULE_SRC_PROPERTY, MODULE_URL_PROPERTY, MODULE_WINDOWS_PROPERTY`

### Fields inherited from interface net.shibboleth.idp.module.IdPModule

`IDPNEW_EXT_BASE, IDPSAVE_EXT`

## Constructor Summary

Constructors
Modifier
Constructor
Description
``
`PropertyDrivenIdPModule(InputStream inputStream)`
Constructor.
``
`PropertyDrivenIdPModule(Class<? extends IdPModule> claz)`
Constructor.
`protected`
`PropertyDrivenIdPModule(String version, InputStream inputStream)`
Constructor for version-overriding subclasses.
`protected`
`PropertyDrivenIdPModule(String version, Class<? extends IdPModule> claz)`
Constructor for version-overriding subclasses.
`protected`
`PropertyDrivenIdPModule(String version, Properties properties)`
Constructor for version-overriding subclasses.
``
`PropertyDrivenIdPModule(Properties properties)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`String`
`getNewExtension()`
`String`
`getSaveExtension()`

### Methods inherited from class net.shibboleth.profile.module.PropertyDrivenModule

`disable, enable, getDescription, getId, getName, getOwnerId, getURL, isHttpClientRequired, load, setURL`

### Methods inherited from class net.shibboleth.profile.module.AbstractModule

`equals, getResources, hashCode, isEnabled, setResources, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.IdentifiedComponent

`getId`

### Methods inherited from interface net.shibboleth.profile.module.Module

`disable, enable, enable, getDescription, getName, getOwnerId, getResources, getURL, isEnabled, isHttpClientRequired`

## Constructor Details

### PropertyDrivenIdPModule

public PropertyDrivenIdPModule(@Nonnull Class<? extends IdPModule> claz) throws IOException, ModuleException
Constructor.

Parameters:
  `claz` - type of object used to locate default module.properties resource
Throws:
  `IOException` - if unable to read file
  `ModuleException` - if the module is not in a valid state

### PropertyDrivenIdPModule

public PropertyDrivenIdPModule(@Nonnull InputStream inputStream) throws IOException, ModuleException
Constructor.

Parameters:
  `inputStream` - property stream
Throws:
  `IOException` - if unable to read file
  `ModuleException` - if the module is not in a valid state

### PropertyDrivenIdPModule

public PropertyDrivenIdPModule(@Nonnull Properties properties) throws ModuleException
Constructor.

Parameters:
  `properties` - property set
Throws:
  `ModuleException` - if the module is not in a valid state

### PropertyDrivenIdPModule

protected PropertyDrivenIdPModule(@Nullable String version, @Nonnull Class<? extends IdPModule> claz) throws IOException, ModuleException
Constructor for version-overriding subclasses.

Parameters:
  `version` - overridden version
  `claz` - type of object used to locate default module.properties resource
Throws:
  `IOException` - if unable to read file
  `ModuleException` - if the module is not in a valid state
Since:
  5.1.0

### PropertyDrivenIdPModule

protected PropertyDrivenIdPModule(@Nullable String version, @Nonnull InputStream inputStream) throws IOException, ModuleException
Constructor for version-overriding subclasses.

Parameters:
  `version` - overridden version
  `inputStream` - property stream
Throws:
  `IOException` - if unable to read file
  `ModuleException` - if the module is not in a valid state
Since:
  5.1.0

### PropertyDrivenIdPModule

protected PropertyDrivenIdPModule(@Nullable String version, @Nonnull Properties properties) throws ModuleException
Constructor for version-overriding subclasses.

Parameters:
  `version` - overridden version
  `properties` - property set
Throws:
  `ModuleException` - if the module is not in a valid state
Since:
  5.1.0

## Method Details

### getSaveExtension

@Nonnull public String getSaveExtension()

Specified by:
  `getSaveExtension` in interface `IdPModule`
Specified by:
  `getSaveExtension` in interface `Module`

### getNewExtension

@Nonnull public String getNewExtension()

Specified by:
  `getNewExtension` in interface `IdPModule`
Specified by:
  `getNewExtension` in interface `Module`